OpenShot Audio Library | OpenShotAudio: juce::SpinLock Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::SpinLock Class Reference

`#include <juce_SpinLock.h>`

## Public Types
using | ScopedLockType = GenericScopedLock< SpinLock >
using | ScopedUnlockType = GenericScopedUnlock< SpinLock >

## Public Member Functions
void | enter () const noexcept
bool | tryEnter () const noexcept
void | exit () const noexcept

## Detailed Description

A simple spin-lock class that can be used as a simple, low-overhead mutex for uncontended situations.

Note that unlike a CriticalSection, this type of lock is not re-entrant, and may be less efficient when used in a highly contended situation, but it's very small and requires almost no initialisation. It's most appropriate for simple situations where you're only going to hold the lock for a very brief time.

See also
  CriticalSection

Definition at line 41 of file juce_SpinLock.h.

## Member Typedef Documentation

## ◆ ScopedLockType

using juce::SpinLock::ScopedLockType = GenericScopedLock<SpinLock>

Provides the type of scoped lock to use for locking a SpinLock.

Definition at line 73 of file juce_SpinLock.h.

## ◆ ScopedUnlockType

using juce::SpinLock::ScopedUnlockType = GenericScopedUnlock<SpinLock>

Provides the type of scoped unlocker to use with a SpinLock.

Definition at line 76 of file juce_SpinLock.h.

## Member Function Documentation

## ◆ enter()

void juce::SpinLock::enter | ( |  | ) | const
| noexcept

Acquires the lock. This will block until the lock has been successfully acquired by this thread. Note that a SpinLock is NOT re-entrant, and is not smart enough to know whether the caller thread already has the lock - so if a thread tries to acquire a lock that it already holds, this method will never return!

It's strongly recommended that you never call this method directly - instead use the ScopedLockType class to manage the locking using an RAII pattern instead.

Definition at line 334 of file juce_Thread.cpp.

Referenced by juce::ReadWriteLock::enterWrite().

## ◆ exit()

void juce::SpinLock::exit | ( |  | ) | const
| inlinenoexcept

Releases the lock.

Definition at line 65 of file juce_SpinLock.h.

Referenced by juce::ReadWriteLock::enterWrite().

## ◆ tryEnter()

bool juce::SpinLock::tryEnter | ( |  | ) | const
| inlinenoexcept

Attempts to acquire the lock, returning true if this was successful.

Definition at line 59 of file juce_SpinLock.h.

Referenced by enter().

The documentation for this class was generated from the following files:

- juce_SpinLock.h
- juce_Thread.cpp